=== debian/changelog ===
magics++ (4.0.3-1) unstable; urgency=medium

  * New upstream release
  * Remove python support. Will be in a separate package
  * Make libmagics++-dev python scripts python3 (python3 patch)
  * Standards-Version: 4.3.0
  * Build-Depend on gfortran | fortran-compiler
  * Add ACCEPT_USE_OF_DEPRECATED_PROJ_API_H to CFLAGS, CXXFLAGS for Proj 6.0.0
    transition
  * Delete all .DS_Store files
  * Debhelper 12
  * Override and bypass dwz in this build

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 15 Jun 2019 12:09:27 +0100
